/***************************************************************************************
子機XBeeのUARTからのシリアル情報を受信する

                                                       Copyright (c) 2013 Wataru KUNINO
***************************************************************************************/
#include <xbee.h>
#include <LiquidCrystal.h>

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
byte dev[8];                                    // XBee子機のアドレス保存用

void setup() {
    lcd.begin(16, 2);                           // LCDのサイズを16文字×2桁に設定
    lcd.clear();                                // 画面消去
    lcd.print("Example 40 UART ");              // 文字を表示
    xbee_init( 0 );                             // XBee用COMポートの初期化
    xbee_atnj( 0xFF );                          // 子機XBeeデバイスを常に参加受け入れ
    lcd.setCursor(0, 1);                        // LCDのカーソル位置を2行目の先頭に
    lcd.print("Waiting for XBee");              // 待ち受け中の表示
}

void loop() {
    byte i;
    XBEE_RESULT xbee_result;                    // 受信データ(詳細)

    xbee_rx_call( &xbee_result );               // データを受信して変数dataに代入
    switch( xbee_result.MODE ){                 // 受信したデータの内容に応じて
        case MODE_UART:                         // 子機XBeeから文字データを受信した時
            lcd.clear();                        // 画面消去
            for(i=0;i<16;i++){
                if(xbee_result.DATA[i]==0x00) break;
                lcd.print( (char)xbee_result.DATA[i] );      // 受信結果(テキスト)を表示
            }
            break;
        case MODE_IDNT:                         // 子機がコミッションボタンを押した時
            lcd.clear();                        // 画面消去
            lcd.print("Found a New Dev.");
            xbee_atnj(0);                       // 子機の受け入れ拒否を設定
            for(i=0;i<8;i++) dev[i]=xbee_result.FROM[i];    // アドレスをdevにコピー
            xbee_ratnj(dev,0);                  // 子機に対して孫機の受け入れ拒否を設定
            xbee_ratd_myaddress( dev );         // 子機に本機のアドレス設定を行う
            xbee_uart(dev,"Hello!\r");          // 子機に文字を送信
            break;
    }
}
