/***************************************************************************************
Digi純正XBee Sensorで照度と温度を測定する

                                                       Copyright (c) 2013 Wataru KUNINO
***************************************************************************************/
#include <xbee.h>
#include <LiquidCrystal.h>
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

void setup() {
    lcd.begin(16, 2);                           // LCDのサイズを16文字×2桁に設定
    lcd.clear();                                // 画面消去
    lcd.print("Example 42 Sens.");              // 文字を表示
    xbee_init( 0 );                             // XBee用COMポートの初期化
    lcd.setCursor(0, 1);                        // LCDのカーソル位置を2行目の先頭に
    xbee_atnj( 0xFF );                          // 子機XBeeデバイスを常に参加受け入れ
    lcd.print("Waiting for XBee");              // 待ち受け中の表示
}

void loop() {
    byte i;
    byte dev[8];                                // XBee子機デバイスのアドレス
    float value;                                // 受信データの代入用
    XBEE_RESULT xbee_result;                    // 受信データ(詳細)

    xbee_rx_call( &xbee_result );               // データを受信
    switch( xbee_result.MODE ){                 // 受信したデータの内容に応じて
        case MODE_GPIN:                         // 子機XBeeの自動送信の受信
            // 照度測定結果をvalueに代入して表示する
            value = xbee_sensor_result( &xbee_result, LIGHT);
            lcd.clear();
            lcd.print(value, 1);
            lcd.print(" Lux");
            // 温度測定結果をvalueに代入して表示する
            value = xbee_sensor_result( &xbee_result, TEMP);
            lcd.setCursor(0, 1);
            lcd.print(value, 1);
            lcd.print(" degC");
            break;
        case MODE_IDNT:                         // 新しいデバイスを発見
            lcd.clear();
            lcd.print("Found New Device");
            xbee_atnj(0);                       // 子機XBeeデバイスの参加制限設定
            for(i=0;i<8;i++) dev[i]=xbee_result.FROM[i];    // アドレスをdevにコピー
            /* XBee子機のGPIOを設定 */
            xbee_gpio_config( dev, 1 , AIN );   // XBee子機のポート1をアナログ入力へ
            xbee_gpio_config( dev, 2 , AIN );   // XBee子機のポート2をアナログ入力へ
            /* XBee子機をスリープに設定 */
            xbee_end_device(dev, 3, 3, 0);      // 起動間隔3秒,測定間隔3秒,SLEEP端子無効
            break;
    }
}
