/***************************************************************************************
XBeeスイッチとXBeeブザーで玄関呼鈴を製作する

                                                       Copyright (c) 2013 Wataru KUNINO
***************************************************************************************/
#include <xbee.h>
#include <LiquidCrystal.h>
#include "pitches.h"
#define  PIN_BUZZER  2                      // Digital 2にスピーカを接続

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
byte dev[8];                                // XBee子機(スイッチ)デバイスのアドレス

void setup() {
    lcd.begin(16, 2);                       // LCDのサイズを16文字×2桁に設定
    lcd.clear();                            // 画面消去
    lcd.print("Example 50 Bell ");          // 文字を表示
    xbee_init( 0 );                         // XBee用COMポートの初期化
    lcd.setCursor(0, 1);
    lcd.print("Waiting for SW  ");
    while( xbee_atnj(30)==0 );              // デバイスの参加受け入れ
    xbee_from( dev );                       // 見つけた子機のアドレスを変数devへ
    xbee_gpio_init( dev );                  // 子機のDIOにIO設定を行う
    xbee_end_device(dev, 20, 0, 1);         // 起動間隔20秒,自動測定OFF,SLEEP端子有効
    lcd.setCursor(0, 1);
    lcd.print("Press Switch    ");
}

void loop() {
    XBEE_RESULT xbee_result;

    xbee_rx_call( &xbee_result );               // データを受信
    if( xbee_result.MODE==MODE_GPIN ){          // 子機XBeeからのIOデータ受信
        lcd.setCursor(0, 1);
        if(xbee_result.GPI.PORT.D1 == 0){       // ポート1が押された
            lcd.print("Ringing         ");
            tone(PIN_BUZZER,NOTE_AS7,500);      // ブザーに音階A#7を出力
        }else{
            lcd.print("Press Switch    ");
            tone(PIN_BUZZER,NOTE_FS6,750);     // ブザーに音階F#6を出力
        }
    }
}
